-
Notifications
You must be signed in to change notification settings - Fork 16
/
Copy pathxEndMotorPlate.py
413 lines (362 loc) · 19.4 KB
/
xEndMotorPlate.py
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
216
217
218
219
220
221
222
223
224
225
226
227
228
229
230
231
232
233
234
235
236
237
238
239
240
241
242
243
244
245
246
247
248
249
250
251
252
253
254
255
256
257
258
259
260
261
262
263
264
265
266
267
268
269
270
271
272
273
274
275
276
277
278
279
280
281
282
283
284
285
286
287
288
289
290
291
292
293
294
295
296
297
298
299
300
301
302
303
304
305
306
307
308
309
310
311
312
313
314
315
316
317
318
319
320
321
322
323
324
325
326
327
328
329
330
331
332
333
334
335
336
337
338
339
340
341
342
343
344
345
346
347
348
349
350
351
352
353
354
355
356
357
358
359
360
361
362
363
364
365
366
367
368
369
370
371
372
373
374
375
376
377
378
379
380
381
382
383
384
385
386
387
388
389
390
391
392
393
394
395
396
397
398
399
400
401
402
403
404
405
406
407
408
409
410
411
412
413
# Copyright 2015 Matthew Rogge
#
# This file is part of Retr3d.
#
# Retr3d is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Retr3d is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Retr3d. If not, see <http://www.gnu.org/licenses/>.
#import Math stuff
from __future__ import division # allows floating point division from integersimport math
import math
from itertools import product
#import FreeCAD modules
import FreeCAD as App
import FreeCAD# as #
import Part
import Sketcher
import Draft
#Specific to printer
import globalVars as gv
import utilityFunctions as uf
#notes
#Nut facetoface top and bottom should be resolved into a max
class XEndMotorPlate(object):
def __init__(self):
pass
def assemble(self):
App.ActiveDocument=App.getDocument("xEndMotorPlate")
shape = App.ActiveDocument.ActiveObject.Shape
App.ActiveDocument=App.getDocument("PrinterAssembly")
App.ActiveDocument.addObject('Part::Feature','xEndMotorPlate').Shape= shape
#Color Part change colors to metal
#Rotate into correct orientation
rotateAngle = -90
rotateCenter = App.Vector(0,0,0)
rotateAxis = App.Vector(1,0,0)
Draft.rotate([App.ActiveDocument.xEndMotorPlate],rotateAngle,rotateCenter,axis = rotateAxis,copy=False)
#Define shifts and move the left clamp into place
xShift = -gv.xRodLength/2-gv.xMotorBodyWidth-gv.motorToXRodClampSpacing-gv.xRodClampWidth+gv.xRodClampPocketDepth
yShift = (gv.extruderNozzleStandoff
- gv.zRodStandoff
- gv.xEndZRodHolderFaceThickness
- gv.xEndZRodHolderMaxNutFaceToFace/2
- gv.xMotorMountPlateThickness)
zShift = gv.xMotorMountPlateWidth+ (gv.xRodSpacing-gv.xMotorMountPlateWidth)/2
App.ActiveDocument=App.getDocument("PrinterAssembly")
Draft.move([App.ActiveDocument.xEndMotorPlate],App.Vector(xShift, yShift, zShift),copy=False)
App.ActiveDocument.recompute()
shape = App.ActiveDocument.xEndMotorPlate
if shape not in gv.xAxisParts:
gv.xAxisParts.append(shape)
def draw(self):
#helper Variables
#determine total width of motor mount plate
xMotorMountWidth = gv.xMotorBodyWidth + gv.motorToXRodClampSpacing + gv.xRodClampWidth
xRodClampMountHoleSpacingVert = gv.xRodSpacing-2*gv.xRodAxisToMountHoleDist
xRodClampMountHoleSpacingHoriz = gv.xRodClampWidth-2*gv.xRodClampEdgeToMountHoleDist
#safety check
#xRodSpacing must be wide enough for the motor to be mounted between the rods
#Create Document
try:
App.getDocument('xEndMotorPlate').recompute()
App.closeDocument("xEndMotorPlate")
App.setActiveDocument("")
App.ActiveDocument=None
except:
pass
App.newDocument("xEndMotorPlate")
App.setActiveDocument("xEndMotorPlate")
App.ActiveDocument=App.getDocument("xEndMotorPlate")
#Make the plate
#Sketch points
p1x = 0
p1y = 0
p2x = 0
p2y = gv.xMotorMountPlateWidth
p3x = xMotorMountWidth
p3y = gv.xMotorMountPlateWidth
p4x = xMotorMountWidth
p4y = 0
#Make Sketch
App.activeDocument().addObject('Sketcher::SketchObject','Sketch')
App.activeDocument().Sketch.Placement = App.Placement(App.Vector(0.000000,0.000000,0.000000),App.Rotation(0.000000,0.000000,0.000000,1.000000))
App.ActiveDocument.Sketch.addGeometry(Part.Line(App.Vector(p1x,p1y,0),App.Vector(p2x,p2y,0)))
App.ActiveDocument.Sketch.addGeometry(Part.Line(App.Vector(p2x,p2y,0),App.Vector(p3x,p3y,0)))
App.ActiveDocument.Sketch.addGeometry(Part.Line(App.Vector(p3x,p3y,0),App.Vector(p4x,p4y,0)))
App.ActiveDocument.Sketch.addGeometry(Part.Line(App.Vector(p4x,p4y,0),App.Vector(p1x,p1y,0)))
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Coincident',0,2,1,1))
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Coincident',1,2,2,1))
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Coincident',2,2,3,1))
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Coincident',3,2,0,1))
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Vertical',0))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Vertical',2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Horizontal',3))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Horizontal',1))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('Coincident',0,1,-1,1))
App.ActiveDocument.recompute()
#Add dimensions
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('DistanceX',3,-xMotorMountWidth))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch.addConstraint(Sketcher.Constraint('DistanceY',2,-gv.xMotorMountPlateWidth))
App.ActiveDocument.recompute()
App.getDocument('xEndMotorPlate').recompute()
#extrude x motor mount plate
App.activeDocument().addObject("PartDesign::Pad","Pad")
App.activeDocument().Pad.Sketch = App.activeDocument().Sketch
App.activeDocument().Pad.Length = 10.0
App.ActiveDocument.recompute()
App.ActiveDocument.Pad.Length = gv.xMotorMountPlateThickness
App.ActiveDocument.Pad.Reversed = 0
App.ActiveDocument.Pad.Midplane = 0
App.ActiveDocument.Pad.Length2 = 100.000000
App.ActiveDocument.Pad.Type = 0
App.ActiveDocument.Pad.UpToFace = None
App.ActiveDocument.recompute()
#cut holes for xRodClamp
#Sketch Points
p1x = 0
p1y = gv.xMotorMountPlateWidth/2
p2x = xMotorMountWidth
p2y = gv.xMotorMountPlateWidth/2
p3x = gv.xMotorBodyWidth+gv.motorToXRodClampSpacing +gv.xRodClampEdgeToMountHoleDist
p3y = gv.xRodAxisToMountHoleDist
p4x = gv.xMotorBodyWidth+gv.motorToXRodClampSpacing+gv.xRodClampEdgeToMountHoleDist
p4y = gv.xMotorMountPlateWidth-gv.xRodAxisToMountHoleDist
p5x = xMotorMountWidth-gv.xRodClampEdgeToMountHoleDist
p5y = gv.xMotorMountPlateWidth-gv.xRodAxisToMountHoleDist
p6x = xMotorMountWidth-gv.xRodClampEdgeToMountHoleDist
p6y = gv.xRodAxisToMountHoleDist
p7x = gv.xMotorBodyWidth+gv.motorToXRodClampSpacing+gv.xRodClampEdgeToMountHoleDist
p7y = gv.xMotorMountPlateWidth/2
p8x = gv.xMotorBodyWidth+gv.motorToXRodClampSpacing+gv.xRodClampWidth/2
p8y = gv.xMotorMountPlateWidth/2
#Make sketch
App.activeDocument().addObject('Sketcher::SketchObject','Sketch001')
App.activeDocument().Sketch001.Support = uf.getFace(App.ActiveDocument.Pad,
None, None,
None, None,
gv.xMotorMountPlateThickness, 0)#(App.ActiveDocument.Pad,["Face6"])
App.activeDocument().recompute()
App.ActiveDocument.Sketch001.addExternal("Pad",uf.getEdge(App.ActiveDocument.Pad,
0,0,
gv.xMotorMountPlateWidth/2,0,
gv.xMotorMountPlateThickness,0))
App.ActiveDocument.Sketch001.addExternal("Pad",uf.getEdge(App.ActiveDocument.Pad,
xMotorMountWidth,0,
gv.xMotorMountPlateWidth/2,0,
gv.xMotorMountPlateThickness,0))
App.ActiveDocument.Sketch001.addGeometry(Part.Line(App.Vector(p1x,p1y,0),App.Vector(p2x,p2y,0)))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('PointOnObject',0,1,-3))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('PointOnObject',0,2,-4))
App.ActiveDocument.Sketch001.addGeometry(Part.Line(App.Vector(p3x,p3y,0),App.Vector(p4x,p4y,0)))
App.ActiveDocument.Sketch001.addGeometry(Part.Line(App.Vector(p4x,p4y,0),App.Vector(p5x,p5y,0)))
App.ActiveDocument.Sketch001.addGeometry(Part.Line(App.Vector(p5x,p5y,0),App.Vector(p6x,p6y,0)))
App.ActiveDocument.Sketch001.addGeometry(Part.Line(App.Vector(p6x,p6y,0),App.Vector(p3x,p3y,0)))
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Coincident',1,2,2,1))
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Coincident',2,2,3,1))
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Coincident',3,2,4,1))
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Coincident',4,2,1,1))
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Horizontal',2))
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Horizontal',4))
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Vertical',1))
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Vertical',3))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.toggleConstruction(0)
App.ActiveDocument.Sketch001.toggleConstruction(4)
App.ActiveDocument.Sketch001.toggleConstruction(3)
App.ActiveDocument.Sketch001.toggleConstruction(2)
App.ActiveDocument.Sketch001.toggleConstruction(1)
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addGeometry(Part.Point(App.Vector(p7x,p7y,0)))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('PointOnObject',5,1,1))
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('PointOnObject',5,1,0))
App.ActiveDocument.Sketch001.addGeometry(Part.Circle(App.Vector(p3x,p3y,0),App.Vector(0,0,1),gv.mountToPrintedDia/2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Coincident',1,1,6,3))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addGeometry(Part.Circle(App.Vector(p4x,p4y,0),App.Vector(0,0,1),gv.mountToPrintedDia/2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Coincident',7,3,1,2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addGeometry(Part.Circle(App.Vector(p5x,p5y,0),App.Vector(0,0,1),gv.mountToPrintedDia/2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Coincident',2,2,8,3))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addGeometry(Part.Circle(App.Vector(p6x,p6y,0),App.Vector(0,0,1),gv.mountToPrintedDia/2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Coincident',9,3,3,2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Equal',6,7))
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Equal',7,8))
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Equal',8,9))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addGeometry(Part.Circle(App.Vector(p8x,p8y,0),App.Vector(0,0,1),gv.xEndIdlerHoleDia/2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('PointOnObject',10,3,0))
App.ActiveDocument.recompute()
#add dimensions
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('DistanceX',4, -xRodClampMountHoleSpacingHoriz))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Distance',3,2,-4,gv.xRodClampEdgeToMountHoleDist))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('DistanceY',3,-xRodClampMountHoleSpacingVert))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Radius',8,gv.mountToPrintedDia/2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Radius',10,gv.xEndIdlerHoleDia/2))
App.ActiveDocument.recompute()
#add Symmetric constraints
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Symmetric',1,1,1,2,5,1))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Symmetric',1,1,2,2,10,3))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch001.addConstraint(Sketcher.Constraint('Symmetric',-1,1,-3,2,0,1))
App.ActiveDocument.recompute()
#exit sketch
App.getDocument('xEndMotorPlate').recompute()
#Cut holes through all
App.activeDocument().addObject("PartDesign::Pocket","Pocket")
App.activeDocument().Pocket.Sketch = App.activeDocument().Sketch001
App.activeDocument().Pocket.Length = 5.0
App.ActiveDocument.recompute()
App.ActiveDocument.Pocket.Length = 5.000000
App.ActiveDocument.Pocket.Type = 1
App.ActiveDocument.Pocket.UpToFace = None
App.ActiveDocument.recompute()
#Cut holes for motor
#Sketch Points
p1x = 0
p1y = gv.xMotorMountPlateWidth/2
p2x = xMotorMountWidth
p2y = gv.xMotorMountPlateWidth/2
p3x = gv.xEndMotorMountHoleDia/2+gv.xEndMotorMountHolePadding
p3y = gv.xMotorMountPlateWidth/2-gv.xMotorShaftToMountHoleDistX
p4x = gv.xEndMotorMountHoleDia/2+gv.xEndMotorMountHolePadding
p4y = gv.xMotorMountPlateWidth/2+gv.xMotorShaftToMountHoleDistX
p5x = gv.xEndMotorMountHoleDia/2+gv.xEndMotorMountHolePadding+2*gv.xMotorShaftToMountHoleDistX
p5y = gv.xMotorMountPlateWidth/2+gv.xMotorShaftToMountHoleDistX
p6x = gv.xEndMotorMountHoleDia/2+gv.xEndMotorMountHolePadding+2*gv.xMotorShaftToMountHoleDistX
p6y = gv.xMotorMountPlateWidth/2-gv.xMotorShaftToMountHoleDistX
p7x = gv.xEndMotorMountHoleDia/2+gv.xEndMotorMountHolePadding
p7y = gv.xMotorMountPlateWidth/2
p8x = gv.xMotorBodyWidth/2
p8y = gv.xMotorMountPlateWidth/2
#Make Sketch
App.activeDocument().addObject('Sketcher::SketchObject','Sketch002')
App.activeDocument().Sketch002.Support = uf.getFace(App.ActiveDocument.Pocket,
None, None,
None, None,
gv.xMotorMountPlateThickness, 0)#(App.ActiveDocument.Pocket,["Face5"])
App.activeDocument().recompute()
App.ActiveDocument.Sketch002.addExternal("Pocket",uf.getEdge(App.ActiveDocument.Pocket,
0,0,
gv.xMotorMountPlateWidth/2,0,
gv.xMotorMountPlateThickness,0))
App.ActiveDocument.Sketch002.addExternal("Pocket",uf.getEdge(App.ActiveDocument.Pocket,
xMotorMountWidth,0,
gv.xMotorMountPlateWidth/2,0,
gv.xMotorMountPlateThickness,0))
App.ActiveDocument.Sketch002.addGeometry(Part.Line(App.Vector(p1x,p1y,0),App.Vector(p2x,p2y,0)))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('PointOnObject',0,2,-4))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Symmetric',-1,1,-3,2,0,1))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Horizontal',0))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addGeometry(Part.Line(App.Vector(p3x,p3y,0),App.Vector(p4x,p4y,0)))
App.ActiveDocument.Sketch002.addGeometry(Part.Line(App.Vector(p4x,p4y,0),App.Vector(p5x,p5y,0)))
App.ActiveDocument.Sketch002.addGeometry(Part.Line(App.Vector(p5x,p5y,0),App.Vector(p6x,p6y,0)))
App.ActiveDocument.Sketch002.addGeometry(Part.Line(App.Vector(p6x,p6y,0),App.Vector(p3x,p3y,0)))
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Coincident',1,2,2,1))
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Coincident',2,2,3,1))
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Coincident',3,2,4,1))
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Coincident',4,2,1,1))
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Horizontal',2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Horizontal',4))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Vertical',3))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Vertical',1))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Equal',3,4))
App.ActiveDocument.recompute()
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.toggleConstruction(0)
App.ActiveDocument.Sketch002.toggleConstruction(2)
App.ActiveDocument.Sketch002.toggleConstruction(3)
App.ActiveDocument.Sketch002.toggleConstruction(4)
App.ActiveDocument.Sketch002.toggleConstruction(1)
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addGeometry(Part.Point(App.Vector(p7x,p7y,0)))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('PointOnObject',5,1,0))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('PointOnObject',5,1,1))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Distance',1,1,-3,gv.xEndMotorMountHoleDia/2+gv.xEndMotorMountHolePadding))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('DistanceX',4,-2*gv.xMotorShaftToMountHoleDistX))
App.ActiveDocument.Sketch002.addGeometry(Part.Circle(App.Vector(p3x,p3y,0),App.Vector(0,0,1),gv.xEndMotorMountHoleDia/2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Coincident',6,3,1,1))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addGeometry(Part.Circle(App.Vector(p5x,p5y,0),App.Vector(0,0,1),gv.xEndMotorMountHoleDia/2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Coincident',7,3,2,2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addGeometry(Part.Circle(App.Vector(p8x,p8y,0),App.Vector(0,0,1),gv.xMotorPulleyDia/2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('PointOnObject',8,3,0))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Equal',6,7))
App.ActiveDocument.recompute()
#Add dimensions to holes
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Radius',6,gv.xEndMotorMountHoleDia/2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Radius',8,gv.xMotorPulleyDia/2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Symmetric',1,1,2,2,8,3))
App.ActiveDocument.recompute()
#Cut 2 more holes if there are 4 motor mount holes
if gv.xEndNumMountHoles==4:
App.ActiveDocument.Sketch002.addGeometry(Part.Circle(App.Vector(p4x,p4y,0),App.Vector(0,0,1),gv.xEndMotorMountHoleDia/2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Coincident',9,3,1,2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addGeometry(Part.Circle(App.Vector(p6x,p6y,0),App.Vector(0,0,1),gv.xEndMotorMountHoleDia/2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Coincident',10,3,3,2))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Equal',10,9))
App.ActiveDocument.recompute()
App.ActiveDocument.Sketch002.addConstraint(Sketcher.Constraint('Equal',10,7))
#exit Sketch
App.getDocument('xEndMotorPlate').recompute()
#Cut holes
App.activeDocument().addObject("PartDesign::Pocket","Pocket001")
App.activeDocument().Pocket001.Sketch = App.activeDocument().Sketch002
App.activeDocument().Pocket001.Length = 5.0
App.ActiveDocument.recompute()
App.ActiveDocument.Pocket001.Length = 5.000000
App.ActiveDocument.Pocket001.Type = 1
App.ActiveDocument.Pocket001.UpToFace = None
App.ActiveDocument.recompute()
#set view as axiometric